/*------------------------------------------------------------------------
 * Copyright (C) 2011 For the list of authors, see file AUTHORS.
 *
 * This file is part of SOFI2D_sh.
 * 
 * SOFI2D_sh is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.0 of the License only.
 * 
 * SOFI2D_sh is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SOFI2D_sh. See file COPYING and/or 
  * <http://www.gnu.org/licenses/gpl-2.0.html>.
--------------------------------------------------------------------------*/
/*------------------------------------------------------------------------
 *  Parallel 2-D-Viscoelastic Finite Difference Modelling 
 *
 *  VERSION 1.7 
 *  
 *  last update 11/07/2002
 *
 *  Copyright (c) T. Bohlen
 *  
 *
 * 
 * In case of questions contact the author:                       
 *	Dr. Thomas Bohlen, Kiel University, Institute of Geoscience,
 *	Otto-Hahn-Platz 1, D-24098 Kiel, Germany, ph: +49 431 880 4648,
 *	fax: +49 431 880 4432, mailto:tbohlen@geophysik.uni-kiel.de,
 *	Homepage: http://www.geophysik.uni-kiel.de/~tbohlen
 *
 *
 *  Please do not freely distribute the program. In case of interest of other
 *  people in obtaining the source code please refer them to the author.
 *  I would like to keep track where the program is used and modified.
 *  If you show modelling results in a paper or presentation please give a reference
 *  to the following paper:
 *  Bohlen, 2002, Parallel 3-D viscoelastic finite-difference seismic modelling,
 *  Computers and Geociences, 28, pp 887-899 .
 *
 *  Thank you for your co-operation, 
 *  Thomas Bohlen
 

	History of major modifications:

	Oct . 2002	Version 1.0	original parallel implementation
					T. Bohlen
					


 *  ----------------------------------------------------------------------*/

#include "fd.h"           /* general include file for viscoelastic FD programs */

#include "globvar.h"      /* definition of global variables  */


int main(int argc, char **argv){
/* variables in main */
int ns, nseismograms=0, i, nt;
int lsnap, nsnap=0, lsamp=0, buffsize;
int ntr=0, ntr_loc=0, ntr_glob=0, nsrc=0, nsrc_loc=0;

float memdyn, memmodel, memseismograms, membuffer, memtotal;
float fac1, fac2;
char *buff_addr, ext[10];
double 	time1, time2, time3, time4, time5, time6, time7, time8,
	time_av_v_update=0.0, time_av_s_update=0.0, time_av_v_exchange=0.0, 
	time_av_s_exchange=0.0, time_av_timestep=0.0;


float  **  psxz, **  psyz;
float  **  pvz;
float  ***  pr, ***  pp;
float  **  prho,  **  pu;
float  **  ptaus, *  peta;
float * etaip, * etajp;

float  ** sectionvz=NULL;
float  **  absorb_coeff;
float  ** srcpos=NULL, **srcpos_loc=NULL, ** signals=NULL;
int   **recpos=NULL, ** recpos_loc=NULL;

float ** bufferlef_to_rig,  ** bufferrig_to_lef,
** buffertop_to_bot, ** bufferbot_to_top; 
	


/* Initialize MPI environment */
MPI_Init(&argc,&argv);
MPI_Comm_size(MPI_COMM_WORLD,&NP);
MPI_Comm_rank(MPI_COMM_WORLD,&MYID);

if (MYID == 0){
   time1=MPI_Wtime(); 
   clock();
  }
		

/* print program name, version etc to stdout*/
if (MYID == 0) info(stdout);

  
/* read parameters from parameter-file (stdin) */
read_par(stdin); 
exchange_par(); 

if (MYID == 0) note(stdout);


 
/* open log-file (each PE is using different file) */
/*	fp=stdout; */
sprintf(ext,".%i",MYID);  
strcat(LOG_FILE,ext);
if ((MYID==0) && (LOG==1)) FP=stdout;
else FP=fopen(LOG_FILE,"w");
fprintf(FP," This is the log-file generated by PE %d \n\n",MYID);
	

/* domain decomposition */
initproc();


NT=iround(TIME/DT);  	  /* number of timesteps */
ns=iround(NT/NDT);           /* number of samples per trace */
lsnap=iround(TSNAP1/DT);      /* first snapshot at this timestep */
lsamp=NDT;


/* output of parameters to log-file or stdout */
if (MYID==0)
   write_par(FP);



	
/* NXG, NYG denote size of the entire (global) grid */
NXG=NX;
NYG=NY;

/* In the following, NX and NY denote size of the local grid ! */
NX = IENDX;
NY = IENDY;


if (SEISMO){
   recpos=receiver(FP, &ntr);
   recpos_loc = splitrec(recpos,&ntr_loc, ntr);
   ntr_glob=ntr;
   ntr=ntr_loc;
}



/* estimate memory requirement of the variables in megabytes*/
	
switch (SEISMO){
case 1 : /* particle velocities only */
	nseismograms=1;	
	break;	
}	
	


/*allocate memory for dynamic, static and buffer arrays */
fac1=(NX+4.0)*(NY+4.0);
fac2=sizeof(float)*pow(2.0,-20.0);

memdyn=(3.0+2.0*(float)L)*fac1*fac2;
memmodel=4.0*fac1*fac2;
memseismograms=nseismograms*ntr*ns*fac2;
membuffer=2.0*3.0*(NY+NX)*fac2;
buffsize=2.0*2.0*3.0*(NX +NY)*sizeof(MPI_FLOAT);
memtotal=memdyn+memmodel+memseismograms+membuffer+(buffsize*pow(2.0,-20.0));


if (MYID==0){
   fprintf(FP,"\n **Message from main (printed by PE %d):\n",MYID);
   fprintf(FP," Size of local grids: NX=%d \t NY=%d\n",NX,NY);
   fprintf(FP," Each process is now trying to allocate memory for:\n");
   fprintf(FP," Dynamic variables: \t\t %6.2f MB\n", memdyn);
   fprintf(FP," Static variables: \t\t %6.2f MB\n", memmodel);
   fprintf(FP," Seismograms: \t\t\t %6.2f MB\n", memseismograms);
   fprintf(FP," Buffer arrays for grid exchange:%6.2f MB\n", membuffer);
   fprintf(FP," Network Buffer for MPI_Bsend: \t %6.2f MB\n", buffsize*pow(2.0,-20.0));
   fprintf(FP," ------------------------------------------------ \n");
   fprintf(FP," Total memory required: \t %6.2f MB.\n\n", memtotal);
   }


/* allocate buffer for buffering messages */
buff_addr=malloc(buffsize);
if (!buff_addr) err("allocation failure for buffer for MPI_Bsend !");
MPI_Buffer_attach(buff_addr,buffsize);



/* memory allocation for dynamic (wavefield) arrays */
psxz =  matrix(-1,NY+2,-1,NX+2);
psyz =  matrix(-1,NY+2,-1,NX+2);
pvz  =  matrix(-1,NY+2,-1,NX+2);
pr   =  f3tensor(-1,NY+2,-1,NX+2,1,L);
pp   =  f3tensor(-1,NY+2,-1,NX+2,1,L);
	
/* memory allocation for static (model) arrays */
prho =  matrix(-1,NY+2,-1,NX+2);
pu   =  matrix(-1,NY+2,-1,NX+2);
ptaus=  matrix(-1,NY+2,-1,NX+2);
peta = vector(1,L);
etaip = vector(1,L);
etajp = vector(1,L);
absorb_coeff=  matrix(1,NY,1,NX);

/* memory allocation for buffer arrays in which the wavefield
	   information which is exchanged between neighbouring PEs is stored */
bufferlef_to_rig = matrix(1,NY,1,2);
bufferrig_to_lef = matrix(1,NY,1,2);
buffertop_to_bot = matrix(1,NX,1,2);
bufferbot_to_top = matrix(1,NX,1,2);



if (ntr>0){
	switch (SEISMO){
	case 1 : /* particle velocities only */
		sectionvz=matrix(1,ntr,1,ns);
		break;	
	}
}	


fprintf(FP," ... memory allocation for PE %d was successfull.\n\n", MYID);


/* Reading source positions from SOURCE_FILE */ 	
srcpos=sources(&nsrc);

/* Distribute source positions on subdomains */
srcpos_loc = splitsrc(srcpos,&nsrc_loc, nsrc);


/* calculate wavelet for each source point */
signals=wavelet(srcpos_loc,nsrc_loc);

MPI_Barrier(MPI_COMM_WORLD);


/* create model grids */
model(prho,pu,ptaus,peta);


/* check if the FD run will be stable and free of numerical dispersion */
checkfd(FP,prho,pu,ptaus,peta);

/* calculate 2-D array for exponential damping of reflections
   at the edges of the numerical mesh */
absorb(absorb_coeff);



/* For the calculation of the material parameters beteween gridpoints
	   the have to be averaged. For this, values lying at 0 and NX+1,
	for example, are required on the local grid. These are now copied from the
	neighbouring grids */		
matcopy(prho, pu, ptaus);


MPI_Barrier(MPI_COMM_WORLD);


if (MYID==0)
   {
   time2=MPI_Wtime();
   fprintf(FP,"\n\n\n *********** STARTING TIME STEPPING ***************\n");
   fprintf(FP," real time before starting time loop: %4.2f s.\n",time2-time1);
   }


/*----------------------  loop over timesteps  ------------------*/

for (nt=1;nt<=NT;nt++){     
		
   if (MYID==0){
      fprintf(FP,"\n Computing timestep %d of %d \n",nt,NT);
      printf(" Computing timestep %d of %d \n",nt,NT);
      time3=MPI_Wtime();
   }

		
   /* update of particle velocities */
   update_v(1, NX, 1, NY, nt, pvz, psxz, psyz, prho,
   	    srcpos_loc,signals,nsrc_loc,absorb_coeff); 



   if (MYID==0){
      time4=MPI_Wtime();
      time_av_v_update+=(time4-time3);
      fprintf(FP," particle velocity exchange between PEs ...");
      }

   /* exchange of particle velocities between PEs */
   exchange_v(pvz, bufferlef_to_rig, bufferrig_to_lef, 
      buffertop_to_bot, bufferbot_to_top);

   if (MYID==0){
      time5=MPI_Wtime();
	time_av_v_exchange+=(time5-time4);
      fprintf(FP," finished (real time: %4.2f s).\n",time5-time4);
      }


   update_s(1, NX, 1, NY, pvz, psxz, psyz,
       pr, pp, pu, ptaus, etaip, etajp, peta);
		

   if ((FREE_SURF) && (POS[2]==0))
      surface(0, psyz);	


   if (MYID==0){
      time6=MPI_Wtime();
	time_av_s_update+=(time6-time5);
      fprintf(FP," stress exchange between PEs ...");
      }


   /* stress exchange between PEs */
    exchange_s(psyz,psxz, 
      bufferlef_to_rig, bufferrig_to_lef, 
      buffertop_to_bot, bufferbot_to_top);

 
   if (MYID==0){
      time7=MPI_Wtime();
 	time_av_s_exchange+=(time7-time6);
     fprintf(FP," finished (real time: %4.2f s).\n",time7-time6);
      }


	/* store amplitudes at receivers in section-arrays */
	if ((SEISMO) && (nt==lsamp) && (nt<NT)){
		seismo(lsamp, ntr, recpos_loc, sectionvz, pvz);
		lsamp+=NDT;
	}



   /* WRITE SNAPSHOTS TO DISK */
   if ((SNAP) && (nt==lsnap) && (nt<=TSNAP2/DT)){
      snap(FP,nt,++nsnap,pvz);
      lsnap=lsnap+iround(TSNAPINC/DT);
      }

   if (MYID==0){
      time8=MPI_Wtime();
	time_av_timestep+=(time8-time3);
      fprintf(FP," total real time for timestep %d : %4.2f s.\n",nt,time8-time3);
      }   		


   }/*--------------------  End  of loop over timesteps ----------*/

	
	
   if ((ntr > 0) && (SEISMO)){
	saveseis(FP,sectionvz,recpos,recpos_loc,ntr,srcpos,nsrc,ns);
	}




/* deallocation of memory */
free_matrix(psxz,-1,NY+2,-1,NX+2);
free_matrix(psyz,-1,NY+2,-1,NX+2);
free_matrix(pvz,-1,NY+2,-1,NX+2);
free_f3tensor(pr,-1,NY+2,-1,NX+2,1,L);
free_f3tensor(pp,-1,NY+2,-1,NX+2,1,L);
free_matrix(prho,-1,NY+2,-1,NX+2);
free_matrix(pu,-1,NY+2,-1,NX+2);
free_matrix(ptaus,-1,NY+2,-1,NX+2);
free_vector(peta,1,L);
free_vector(etaip,1,L);
free_vector(etajp,1,L);

free_matrix(absorb_coeff,1,NY,1,NX);

free_matrix(bufferlef_to_rig,1,NY,1,2);
free_matrix(bufferrig_to_lef,1,NY,1,2);
free_matrix(buffertop_to_bot,1,NX,1,2);
free_matrix(bufferbot_to_top,1,NX,1,2);
	
if (nsrc_loc>0){	
	free_matrix(signals,1,nsrc_loc,1,NT);
	free_matrix(srcpos_loc,1,6,1,nsrc_loc);
}
		   

if (SEISMO) free_imatrix(recpos,1,3,1,ntr_glob);

/* free memory for global source positions */
free_matrix(srcpos,1,6,1,nsrc);

if ((ntr>0) && (SEISMO)){	

      free_imatrix(recpos_loc,1,3,1,ntr);
	/* particle velocities only */
	free_matrix(sectionvz,1,ntr,1,ns);

}	
	
/* de-allocate buffer for messages */
MPI_Buffer_detach(buff_addr,&buffsize);
	
/* merge snapshot files created by the PEs into one file */
/* if ((SNAP) && (MYID==0)){ 
	snapmerge(nsnap);
}
*/

MPI_Barrier(MPI_COMM_WORLD);

if (MYID==0){
	fprintf(FP,"\n **Info from main (written by PE %d): \n",MYID);
	fprintf(FP," CPU time of program per PE: %li seconds.\n",clock()/CLOCKS_PER_SEC);
	time8=MPI_Wtime();
	fprintf(FP," Total real time of program: %4.2f seconds.\n",time8-time1);
	time_av_v_update=time_av_v_update/(double)NT;
	time_av_s_update=time_av_s_update/(double)NT;
	time_av_v_exchange=time_av_v_exchange/(double)NT;
	time_av_s_exchange=time_av_s_exchange/(double)NT;
	time_av_timestep=time_av_timestep/(double)NT;
	fprintf(FP," Average times for \n");
	fprintf(FP," velocity update:  \t %5.3f seconds  \n",time_av_v_update);
	fprintf(FP," stress update:  \t %5.3f seconds  \n",time_av_s_update);
	fprintf(FP," velocity exchange:  \t %5.3f seconds  \n",time_av_v_exchange);
	fprintf(FP," stress exchange:  \t %5.3f seconds  \n",time_av_s_exchange);
	fprintf(FP," timestep:  \t %5.3f seconds  \n",time_av_timestep);
		
}

fclose(FP);
MPI_Finalize();
return 0;	

}/*main*/
